IMPLEMENTATION MODULE anilldib;

IMPORT IO;
FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;
FROM BMP IMPORT TBMP;
IMPORT BMP;

TYPE
   ANILLODIB=POINTER TO ANILLONODO;
   ANILLONODO=RECORD
                   sig:ANILLODIB;
                   dibujo:TBMP;
              END;

(*ZONA DE PROCEDIMIENTOS*)


PROCEDURE Inicializa(VAR anillo:ANILLODIB);


BEGIN
    anillo:=NIL;

END Inicializa;


PROCEDURE InsertaAnillo(VAR anillo:ANILLODIB; dib:TBMP):INTEGER; (*Crea un nodo en el anillo con el dibujo dib*)

VAR
  res:INTEGER;
  nuevo,temp:ANILLODIB;

BEGIN
    IF NOT Available(SIZE(ANILLONODO)) THEN (*No hay memoria disponible*)
       res:=-3
    ELSE (*sin problemas de memoria*)
        res:=0;
        NEW(nuevo);
        nuevo^.dibujo:=dib;
        (*Ahora comprobamos donde lo insertamos*)
        IF anillo=NIL THEN (*El anillo esta vacio*)
 	   anillo:=nuevo;
 	   nuevo^.sig:=anillo;       
        ELSE (*Tenemos algun elemento en el anillo*)
           temp:=anillo;
           WHILE (temp^.sig<>anillo) DO
           	 temp:=temp^.sig;
           END;
           temp^.sig:=nuevo;
           nuevo^.sig:=anillo;
        END;
    END;
    RETURN res
END InsertaAnillo;



PROCEDURE RotaAnillo(VAR anillo:ANILLODIB); (*Rota el anillo haciendo que el siguiente nodo sea el primero*)

BEGIN
    anillo:=anillo^.sig;

END RotaAnillo;


PROCEDURE EliminaAnillo(VAR anillo:ANILLODIB); (*Elimina el anillo de dibujos para liberar la memoria*)

VAR
  temp,temp2:ANILLODIB;

BEGIN
    IF anillo<>NIL THEN
       IF anillo^.sig=anillo THEN
          DISPOSE(anillo);
       ELSE (*hay mas de un elemento*)
          temp:=anillo^.sig;
          WHILE (temp<>anillo) DO
                temp2:=temp;
                temp:=temp^.sig;
                DISPOSE(temp2);
          END;
          DISPOSE(anillo);
       END;
    END;

END EliminaAnillo;



PROCEDURE ContAnillo(VAR anillo:ANILLODIB;VAR dib:TBMP):INTEGER;


VAR
  res:INTEGER;

BEGIN
    IF anillo=NIL THEN
       res:=-1; (*El anillo esta vacio*)
    ELSE
       res:=0;
       dib:=anillo^.dibujo;
    END;
    RETURN res
END ContAnillo;


PROCEDURE Destruye(VAR anillo:ANILLODIB);
VAR
  temp,temp2:ANILLODIB;
  control:INTEGER;

BEGIN
    IF anillo<>NIL THEN
       IF anillo^.sig=anillo THEN
          control:=BMP.Destruir(anillo^.dibujo);
          DISPOSE(anillo);
       ELSE (*hay mas de un elemento*)
          temp:=anillo^.sig;
          WHILE (temp<>anillo) DO
                temp2:=temp;
                temp:=temp^.sig;
                control:=BMP.Destruir(temp2^.dibujo);
                DISPOSE(temp2);
          END;
          control:=BMP.Destruir(anillo^.dibujo);
          DISPOSE(anillo);
       END;
    END;



END Destruye;

END anilldib.