IMPLEMENTATION MODULE avion;

FROM Storage IMPORT ALLOCATE, DEALLOCATE, Available;
IMPORT IO,BMP,Constant,enemy;

CONST
  VIDA = Constant.VIDAAVION; (* Energia inicial del avion *)
  POSINIX = Constant.POSINIX;   (* Posicion inicial del avion *)
  POSINIY = Constant.POSINIY;
  DIRINIX = Constant.DIRINIX;    (* Vector de direccion inicial del avion *)
  DIRINIY = Constant.DIRINIY;
  ARCHIVO_AVION = Constant.ARCHIVO_AVION;
  MAX_VELOCIDAD_AVION = Constant.MAX_VELOCIDAD_AVION;

TYPE
  TAvion = POINTER TO NodoAvion;
  NodoAvion = RECORD
                dib:BMP.TBMP;       (* Dibujo del avion *)
                posx,posy:CARDINAL; (* Posicion x,y del avion *)
                dirx,diry:INTEGER;  (* vector de movimiento *)
                energy:CARDINAL;    (* Energia restante del avion *)


              END;


PROCEDURE Crear(VAR a:TAvion):INTEGER;
(* Crea un avion *)

VAR
  dibujo:BMP.TBMP;
  error:INTEGER;

BEGIN
  IF Available(SIZE(TAvion)) THEN
    NEW(a);

    error:=BMP.Inicializa(dibujo);
    IF error<>0 THEN
      RETURN(-5);
    END;

    error:=BMP.CargaArchivo(dibujo,ARCHIVO_AVION);

    CASE error OF
    0:
      a^.dib:=dibujo;
    |
    -1:
      RETURN(error);
    |
    -2:
      RETURN(error);
    |
    -3:
      RETURN(error);
    |
    ELSE
      RETURN(-6);
    END;

    a^.posx:=POSINIX;
    a^.posy:=POSINIY;
    a^.dirx:=DIRINIX;
    a^.diry:=DIRINIY;
    a^.energy:=VIDA;
    RETURN(0);
  ELSE
    (* insuficiente memoria para cargar la estructura *)
    error:=-4;
    RETURN(error);
  END;
END Crear;

PROCEDURE Destruir(VAR a:TAvion);
(* Destruye la estructura TAvion*)
BEGIN
  DISPOSE(a);
END Destruir;


PROCEDURE Cambiar_direccion(VAR a:TAvion;x,y:INTEGER):INTEGER;
(* x,y --> vector de direccion nuevo *)

BEGIN
  IF ((x<(-MAX_VELOCIDAD_AVION)) OR (x>MAX_VELOCIDAD_AVION)) OR (y<(-MAX_VELOCIDAD_AVION))  OR (y>MAX_VELOCIDAD_AVION) THEN
    (* vector incorrecto, se cancela la actualizacion *)
    RETURN(-1);
  ELSE
    a^.dirx:=x;
    a^.diry:=y;
  END;
  RETURN(0);
END Cambiar_direccion;

PROCEDURE Mover(VAR a:TAvion;pantalla:TPantalla);
(* Cambia las coordenadas de posicion del avion *)

BEGIN

  (* veremos como se tiene que chequear si se sale o no de la pantalla *)
  IF ((a^.posx<MAX_VELOCIDAD_AVION) AND ((a^.dirx<0))) OR ((a^.posx>Constant.MAXPANTALLAX-BMP.Anchura(a^.dib)) AND (a^.dirx>0))
     OR ((a^.posy<MAX_VELOCIDAD_AVION) AND (a^.diry<0)) OR ((a^.posy>Constant.MAXPANTALLAY-BMP.Altura(a^.dib)) AND (a^.diry>0)) THEN
    a^.energy:=0;
  ELSE

    IF a^.dirx<0 THEN
      a^.posx:=a^.posx-enemy.ABS(a^.dirx);
    ELSE
      a^.posx:=a^.posx+enemy.ABS(a^.dirx);
    END;
    IF a^.diry<0 THEN
      a^.posy:=a^.posy-enemy.ABS(a^.diry);
    ELSE
      a^.posy:=a^.posy+enemy.ABS(a^.diry);
    END;

    Dibujar(a);
  END;
END Mover;


PROCEDURE Dibujar(a:TAvion);
(* Dibuja el avion en la posicion actual *)
VAR
  error:INTEGER;
BEGIN
  error:=BMP.VisBmpMask(a^.dib,a^.posx,a^.posy,Constant.MASK);

END Dibujar;


PROCEDURE Pos(avion:TAvion;VAR x,y:CARDINAL);

BEGIN
    x:=avion^.posx+(BMP.Anchura(avion^.dib) DIV 2);
    y:=avion^.posy+(BMP.Altura(avion^.dib) DIV 2);

END Pos;

PROCEDURE Dir(avion:TAvion;VAR x,y:INTEGER);

BEGIN
    x:=avion^.dirx;
    y:=avion^.diry;

END Dir;

PROCEDURE Power(avion:TAvion):CARDINAL;

BEGIN
    IF avion<>NIL THEN
       RETURN avion^.energy
    ELSE
       RETURN 0
    END;
END Power;

PROCEDURE InsertaPower(VAR avion:TAvion;x:CARDINAL);


BEGIN
    IF avion<>NIL THEN
       avion^.energy:=x;
    END;
END InsertaPower;


END avion.