IMPLEMENTATION MODULE Pantalla;

IMPORT IO;
FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;
IMPORT Graph;


TYPE
   TNODO=RECORD
             enemy:BOOLEAN;
             damage:CARDINAL;
         END;
   PUNTX=POINTER TO TNodoX;
   TNodoX=RECORD
          	x:CARDINAL;
          	sig:PUNTX;
          	enemy:BOOLEAN;
   	 	damage:CARDINAL;
          END;
   TPantalla=POINTER TO TNodoY;
   TNodoY=RECORD
          	y:CARDINAL;
          	sig:TPantalla;
          	listax:PUNTX;
          END;



(*ZONA DE PROCEDIMIENTOS*)


PROCEDURE PosAntX(pantalla:PUNTX;x:CARDINAL):PUNTX;

VAR
  res:PUNTX;
BEGIN
    IF pantalla=NIL THEN
       res:=NIL;
    ELSE (*Hay algo en la lista*)
       IF pantalla^.x=x THEN
          res:=NIL;
       ELSE (*No es el primero en la lista*)
          res:=pantalla;
          WHILE (res^.sig<>NIL) AND (res^.sig^.x<x) DO
                 res:=res^.sig;
          END;
       END;
    END;
    RETURN res;
END PosAntX;


PROCEDURE PosAnt(pantalla:TPantalla;y:CARDINAL):TPantalla;

VAR
  res:TPantalla;
BEGIN
    IF pantalla=NIL THEN
       res:=NIL;
    ELSE (*Hay algo en la lista*)
       IF pantalla^.y=y THEN
          res:=NIL;
       ELSE (*No es el primero en la lista*)
          res:=pantalla;
          WHILE (res^.sig<>NIL) AND (res^.sig^.y<y) DO
                 res:=res^.sig;
          END;
       END;
    END;
    RETURN res;
END PosAnt;



PROCEDURE InsertaFila(VAR lista:PUNTX;x,damage:CARDINAL):INTEGER;


VAR
  nuevo:PUNTX;
  puntx:PUNTX;

BEGIN
    IF lista=NIL THEN (*Creamos el nodo nuevo y lo insertamos*)
       IF NOT Available(SIZE(TNodoX)) THEN
          RETURN -3
       END;
       NEW(nuevo);
       nuevo^.x:=x;
       nuevo^.sig:=NIL;
       nuevo^.damage:=damage;
       nuevo^.enemy:=TRUE;
       lista:=nuevo;
    ELSE (*Hay algo en la lista*)
       puntx:=PosAntX(lista,x);
       IF puntx=NIL THEN (*Inchertami per la testa*)
          IF NOT Available(SIZE(TNodoX)) THEN
             RETURN -3
          END;
          NEW(nuevo);
          nuevo^.x:=x;
          nuevo^.sig:=lista;
          nuevo^.damage:=damage;
          nuevo^.enemy:=TRUE;
          lista:=nuevo;
       ELSIF (puntx^.sig<>NIL) AND (puntx^.sig^.x=x) THEN (*Que el nodo existe y sobreescribimos el dao*)
          puntx^.sig^.damage:=damage;
       ELSE (*No existe el nodo, lo tenemos que crear*)
          IF NOT Available(SIZE(TNodoX)) THEN
             RETURN -3
          END;
          NEW(nuevo);
          nuevo^.x:=x;
          nuevo^.damage:=damage;
          nuevo^.enemy:=TRUE;
          nuevo^.sig:=puntx^.sig;
          puntx^.sig:=nuevo;

       END;
    END;
    RETURN 0
END InsertaFila;






PROCEDURE Inserta(VAR pantalla:TPantalla;x,y,damage:CARDINAL):INTEGER;


VAR
  nuevo:TPantalla;
  punty:TPantalla;

BEGIN
    IF pantalla=NIL THEN (*Creamos el nodo nuevo y lo insertamos*)
       IF NOT Available(SIZE(TNodoY)) THEN
          RETURN -3
       END;
       NEW(nuevo);
       nuevo^.y:=y;
       nuevo^.sig:=NIL;
       nuevo^.listax:=NIL;
       pantalla:=nuevo;
       IF InsertaFila(nuevo^.listax,x,damage)<>0 THEN
          RETURN -3
       END;
    ELSE (*Hay algo en la lista*)
       punty:=PosAnt(pantalla,y);
       IF punty=NIL THEN (*inchertami per la testa*)
          IF NOT Available(SIZE(TNodoY)) THEN
             RETURN -3
          END;
          NEW(nuevo);
          nuevo^.y:=y;
          nuevo^.sig:=pantalla;
          nuevo^.listax:=NIL;
          IF InsertaFila(nuevo^.listax,x,damage)<>0 THEN
             RETURN -3
          END;
          pantalla:=nuevo;
       ELSIF (punty^.sig<>NIL) AND (punty^.sig^.y=y) THEN (*Que el nodo existe y sobreescribimos el dao*)
          IF InsertaFila(punty^.sig^.listax,x,damage)<>0 THEN
             RETURN -3
          END;
       ELSE (*No existe el nodo, lo tenemos que crear*)
          IF NOT Available(SIZE(TNodoY)) THEN
             RETURN -3
          END;
          NEW(nuevo);
          nuevo^.y:=y;
          nuevo^.listax:=NIL;
          nuevo^.sig:=punty^.sig;
          punty^.sig:=nuevo;
          IF InsertaFila(nuevo^.listax,x,damage)<>0 THEN
             RETURN -3
          END;
       END;
    END;
    RETURN 0
END Inserta;



PROCEDURE Accede(VAR pantalla:TPantalla;x,y:CARDINAL):TNODO;


    PROCEDURE AccedeX(lista:PUNTX;x:CARDINAL;VAR enemy:BOOLEAN;VAR damage:CARDINAL);
     VAR
       puntx:PUNTX;

    BEGIN
        IF lista=NIL THEN
           enemy:=FALSE;
           damage:=0;
        ELSE (*Hay algo en la lista*)
           puntx:=PosAntX(lista,x);
           IF (puntx=NIL) AND (lista^.x=x) THEN
               enemy:=lista^.enemy;
               damage:=lista^.damage;
           ELSE
               IF (puntx^.sig<>NIL) AND (puntx^.sig^.x=x) THEN
                  enemy:=puntx^.sig^.enemy;
                  damage:=puntx^.sig^.damage;
               ELSE
                  enemy:=FALSE;
                  damage:=0;
               END;
           END;
        END;
    END AccedeX;

VAR
  res:TNODO;
  punty:TPantalla;
  tempx:PUNTX;

BEGIN
    IF pantalla=NIL THEN (*no tenemos nada en la lista*)
       res.enemy:=FALSE;
       res.damage:=0;
    ELSE (*hay algo en la lista*)
       punty:=PosAnt(pantalla,y);
       IF (punty=NIL) AND (pantalla^.y=y) THEN
             AccedeX(pantalla^.listax,x,res.enemy,res.damage);
       ELSE
             IF (punty^.sig<>NIL) AND (punty^.sig^.y=y) THEN
                 AccedeX(punty^.sig^.listax,x,res.enemy,res.damage);
             ELSE
                 res.enemy:=FALSE;
                 res.damage:=0;
             END;
          END;
    END;

    RETURN res;
END Accede;



PROCEDURE EliminaNodo(VAR pantalla:TPantalla;x,y:CARDINAL);

    PROCEDURE DestruyeNodoX(VAR lista:PUNTX;x:CARDINAL);
      VAR
        puntx,temp:PUNTX;
    BEGIN
        IF (lista<>NIL) AND (lista^.x=x) THEN
           temp:=lista;
           lista:=lista^.sig;
           DISPOSE(temp);
        ELSE
           puntx:=PosAntX(lista,x);
           IF (puntx<>NIL) AND (puntx^.sig<>NIL) AND (puntx^.sig^.x=x) THEN (*El nodo existe*)
              temp:=puntx^.sig;
              puntx^.sig:=temp^.sig;
              DISPOSE(temp);
           END;
        END;
    END DestruyeNodoX;


VAR
  punty,temp:TPantalla;
  
BEGIN
    IF (pantalla<>NIL) AND (pantalla^.y=y) THEN (*Esta en el primer nodo*)
        DestruyeNodoX(pantalla^.listax,x);
        IF pantalla^.listax=NIL THEN
           punty:=pantalla;
           pantalla:=pantalla^.sig;
           DISPOSE(punty);
        END;
    ELSE (*Buscamo a partir del segundo*)
       punty:=PosAnt(pantalla,y);
       IF (punty<>NIL) AND (punty^.sig<>NIL ) AND (punty^.sig^.y=y) THEN (*Existe, tenemos que borrar el de la lista de x*)
          DestruyeNodoX(punty^.sig^.listax,x);
          IF punty^.sig^.listax=NIL THEN
             temp:=punty^.sig;
             punty^.sig:=temp^.sig;
             DISPOSE(temp);
          END;
       END;   
    END;
END EliminaNodo;





PROCEDURE VaciaEnem(VAR pantalla:TPantalla;x1,y1,x2,y2:CARDINAL):INTEGER; (**)

VAR
  i,j:CARDINAL;

BEGIN
    IF (x1>MAXX) OR (x2>MAXX) OR (y1>MAXY) OR (y2>MAXY) THEN
       RETURN -1
    END;
    IF (x1>x2) OR (y1>y2) THEN (*Las coordenadas no son validas*)
        RETURN -2
    END;
    FOR i:=x1 TO x2 DO
        FOR j:=y1 TO y2 DO
            EliminaNodo(pantalla,i,j);
        END;
    END;
    RETURN 0

END VaciaEnem;


PROCEDURE Destruir(VAR pantalla:TPantalla);

       PROCEDURE DestruyeListaX(VAR lista:PUNTX);
       VAR
       	 temp:PUNTX;
       BEGIN
           WHILE lista<>NIL DO
           	 temp:=lista;
           	 lista:=lista^.sig;
           	 DISPOSE(temp);
           END;
       END DestruyeListaX;

       PROCEDURE DestruyeListaY(VAR lista:TPantalla);
       VAR
       	  temp:TPantalla;
       BEGIN
           WHILE lista<>NIL DO
           	 temp:=lista;
           	 lista:=lista^.sig;
           	 DISPOSE(temp);
           END;
       END DestruyeListaY;	
VAR
   temp:TPantalla;
BEGIN
    IF pantalla <> NIL THEN (*Comprobamos que tenga algo para destruir*)
       temp:=pantalla;
       WHILE temp<>NIL DO
       	     DestruyeListaX(temp^.listax);
       	     temp:=temp^.sig;
       END;
       DestruyeListaY(pantalla);
    END;

END Destruir;



PROCEDURE InicializaPantalla(VAR pantalla:TPantalla); (**)

BEGIN
    pantalla:=NIL;
END InicializaPantalla;


PROCEDURE LlenaEnem(VAR pantalla:TPantalla;x1,y1,x2,y2,damage:CARDINAL):INTEGER; (**)

VAR
  i,j:CARDINAL;
  control:INTEGER;
BEGIN
   IF damage=0 THEN (*Esto es como eliminar los nodos*)
      (*control:=VaciaEnem(pantalla,x1,y1,x2,y2);*) (*Pasamos del tema :-D*)
   ELSE 
    IF (x1>MAXX) OR (x2>MAXX) OR (y1>MAXY) OR (y2>MAXY) THEN
       RETURN -1
    END;
    IF (x1>x2) OR (y1>y2) THEN (*Las coordenadas no son validas*)
        RETURN -2
    END;
    FOR i:=x1 TO x2 DO
        FOR j:=y1 TO y2 DO
            control:=Inserta(pantalla,i,j,damage);
            IF control<>0 THEN
               RETURN control;
            END;
        END;
    END;
   END;
    RETURN 0
END LlenaEnem;

PROCEDURE HayEnem(VAR pantalla:TPantalla;x,y:CARDINAL):BOOLEAN; (**)


VAR
  nodo:TNODO;
BEGIN
    nodo:=Accede(pantalla,x,y);
    RETURN nodo.enemy;
END HayEnem;


PROCEDURE Damage(VAR pantalla:TPantalla;x,y:CARDINAL):CARDINAL; (**)

VAR
  nodo:TNODO;
BEGIN
    nodo:=Accede(pantalla,x,y);
    RETURN nodo.damage;

END Damage;


PROCEDURE PintaPantalla(pantalla:TPantalla);

VAR
  temp:PUNTX;

BEGIN
     WHILE (pantalla<>NIL) DO
           temp:=pantalla^.listax;
           WHILE temp<>NIL DO
                 Graph.Plot(temp^.x,pantalla^.y,15);
                 temp:=temp^.sig;
           END;
           pantalla:=pantalla^.sig;
     END;
     
END PintaPantalla;

END Pantalla.